<?php
// Load VADS API
require_once DIR_APPLICATION.'controller/payment/vads_api.php';

class ControllerPaymentvads extends Controller {
	protected function index() {
	 $this->config_var= $this->config->get('config_error_display');
	 
		$this->load->model('checkout/order');
		$this->language->load('payment/vads');
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
        
		$this->data['vads_gateway_url'] = $this->config->get('vads_gateway_url');   
		
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$this->id = 'payment';
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/vads.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/vads.tpl';
		} else {
			$this->template = 'default/template/payment/vads.tpl';
		}	
		$this->data['vads_contrib'] = 'OpenCart1.4.9_1.0c';
		
		$this->config->set('config_error_display', 0);
		
		
		 
		$currency = VadsApi::findCurrencyByAlphaCode($order_info['currency']);
		if($currency != null) {
			$this->data['vads_currency'] = $currency->num;
		}
		$lang = $this->session->data['language'];
		$this->data['vads_language'] = in_array($lang, VadsApi::getSupportedLanguages()) ? $lang : 'fr';
    	$this->config->set('config_error_display', $this->config_var);   
		$this->data['vads_order_id']= $order_info['order_id']; 
		$this->data['vads_amount']=  ($this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE))*100;
		$this->data['vads_cust_id']= $order_info['customer_id'];   
		$this->data['vads_cust_address']= $order_info['payment_address_1']. ' ' . $order_info['payment_address_2'];   
		$this->data['vads_cust_zip']= $order_info['payment_postcode'];   
		$this->data['vads_cust_country']= $order_info['payment_iso_code_2'];   
		$this->data['vads_cust_email']= $order_info['email'];  
		$this->data['vads_cust_phone']= $order_info['telephone'];   
		$this->data['vads_cust_city']= $order_info['payment_city'];   
		$this->data['vads_cust_name']= $order_info['payment_firstname'] . ' ' .  $order_info['payment_lastname'];   
		
		$this->data['vads_ship_to_name']=  $order_info['shipping_firstname'] . ' ' .  $order_info['shipping_lastname'];   
		$this->data['vads_ship_to_street']= $order_info['shipping_address_1'];
		$this->data['vads_ship_to_street2']=  $order_info['shipping_address_2']; // TODO utiliser ship_to_street2
		$this->data['vads_ship_to_city']= $order_info['shipping_city'];   
		
		$this->data['vads_ship_to_state']= $order_info['shipping_zone_code'];   
		$this->data['vads_ship_to_country']= $order_info['payment_iso_code_2'];   
		$this->data['vads_ship_to_zip']= $order_info['shipping_postcode'];   
		
		$this->data['vads_site_id'] = $this->config->get('vads_site_id');   
		$this->data['vads_key_test']= $this->config->get('vads_key_test');   
		$this->data['vads_key_prod']= $this->config->get('vads_key_prod');  
		 
		$this->data['vads_ctx_mode']= $this->config->get('vads_ctx_mode');   
		$this->data['vads_capture_delay']= $this->config->get('vads_capture_delay');   
		$this->data['vads_payment_cards']= $this->config->get('vads_payment_cards');   
		$this->data['vads_validation_mode']= $this->config->get('vads_validation_mode');   
		
		$this->data['vads_return_mode']= $this->config->get('vads_return_mode');   
		$this->data['vads_redirect_enabled']= $this->config->get('vads_redirect_enabled');   
		$this->data['vads_redirect_success_timeout']= $this->config->get('vads_redirect_success_timeout');   
		$this->data['vads_redirect_success_message']= $this->config->get('vads_redirect_success_message');   
		$this->data['vads_redirect_error_timeout']= $this->config->get('vads_redirect_error_timeout');   
		$this->data['vads_redirect_error_message']= $this->config->get('vads_redirect_error_message');   
		
		$this->data['vads_available_languages']= $this->config->get('vads_available_languages');
		$this->data['vads_minimum_amount']= $this->config->get('vads_minimum_amount');
		$this->data['vads_maximum_amount']= $this->config->get('vads_maximum_amount');
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['vads_url_cancel'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {
			$this->data['vads_url_cancel'] = HTTPS_SERVER . 'index.php?route=checkout/guest_step_2';
		}
		$this->data['vads_url_success']= HTTPS_SERVER . 'index.php?route=payment/vads/return_user&result=success';
		$this->data['vads_url_return']= HTTPS_SERVER . 'index.php?route=payment/vads/return_user&result=error';
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/guest_step_2';
		}
		
		$this->render();
	}
	
	public function callback() {
		$this->load->model('checkout/order');
	
		$vads = new VadsApi();
		$vad_api_resp = $vads->getResponse(
									$_REQUEST, 
									$this->config->get('vads_ctx_mode'),
									$this->config->get('vads_key_test'),
									$this->config->get('vads_key_prod')
								   );
		$this->config->set('config_error_display', 0);
	 	if( !$vad_api_resp->isAuthentified()) {  
	 	  exit($vad_api_resp->getOutputForGateway('auth_fail')); 
	 	}
		$this->config->set('config_error_display', $this->config_var);	
		$order_id=$this->request->post['vads_order_id'];
		
		$order_info = $this->model_checkout_order->getOrder($order_id);
		
		if (empty($order_info)) { 
		    die($vad_api_resp->getOutputForGateway('order_not_found')); 
		}
		else {
			if($order_info['order_status_id'] == '0') {
				$this->model_checkout_order->confirm($order_id, $this->config->get('config_order_status_id'));
				if ($vad_api_resp->isAcceptedPayment()) {
				  echo($vad_api_resp->getOutputForGateway('payment_ok'));
				  $this->model_checkout_order->update($order_id, $this->config->get('vads_order_status_succes_id'), '', TRUE);
				}
				else{
				  $this->model_checkout_order->update($order_id, $this->config->get('vads_order_status_failed_id'), '', TRUE);
				  echo ($vad_api_resp->getOutputForGateway('payment_ko_on_order_ok'));
				}
			 }
			else{	
				// Order already processed
				if($vad_api_resp->isAcceptedPayment()) {
					die ($vad_api_resp->getOutputForGateway('payment_ok_already_done'));
				}
				else {
					die ($vad_api_resp->getOutputForGateway('payment_ko_on_order_ok'));
				}
			}
		
		}
	}
	
	public function return_user() {
		$this->load->model('checkout/order');
		$url_success = $this->config->get('vads_url_success') ;
		$url_error = $this->config->get('vads_url_error') ;
		if (empty($url_success)){
			$url_success = HTTPS_SERVER . 'index.php?route=checkout/success';
		}
		if (empty($url_error)){
	 		$url_error = HTTPS_SERVER . 'index.php?route=checkout/cart';
		}
		
		// Case return_mode == NONE
		if(!isset($_REQUEST)|| !isset($_REQUEST['vads_order_id'])) {
			if(isset($this->request->get['result']) && $this->request->get['result'] == 'success') {
				$this->redirect($url_success);
			} else {
				$this->redirect($url_error);
			}
			die();
		}
		
		$vads = new VadsApi();
		$vad_api_resp = $vads->getResponse(
									$_REQUEST, 
									$this->config->get('vads_ctx_mode'),
									$this->config->get('vads_key_test'),
									$this->config->get('vads_key_prod')
								   );
		
								   
		$order_id = $vad_api_resp->get('order_id');
		
		
		$order_info = $this->model_checkout_order->getOrder($order_id);
		if (empty($order_info)) { 
		    echo "Could not load any order for your notification ".$vad_api_resp->get('order_id');
			return true; 
		}
	
		
		$this->config->set('config_error_display', 0);					   
	 	if( !$vad_api_resp->isAuthentified()) {  
			exit ("Authentication failed.");
	 	 }
	 	$this->config->set('config_error_display', $this->config_var);
	 	 
		if($order_info['order_status_id'] == '0'){
			$this->model_checkout_order->confirm($order_id, $this->config->get('config_order_status_id'));
			if ($vad_api_resp->isAcceptedPayment()) {
			  if($this->config->get('vads_ctx_mode') == 'TEST') {
				// Mode TEST warning : Check URL not correctly called
					//echo "Avertissement mode TEST : la commande a bien été enregistrée, mais la validation automatique n'a pas fonctionné.";
			  }
			  $this->model_checkout_order->update($order_id, $this->config->get('vads_order_status_succes_id'), '', TRUE);
			  $this->redirect($url_success);
			}
			else{
			$this->model_checkout_order->update($order_id, $this->config->get('vads_order_status_failed_id'), '', TRUE);
			   if ($this->config->get('vads_ctx_mode') == 'TEST')
			  {
				// Mode TEST warning : Check URL not correctly called
			  }
			  $this->redirect($url_error);   
			 
			}
		 }
		else{	
		  // Order already processed
		 if($vad_api_resp->isAcceptedPayment()) {
		  	
		 	//$url_success = $this->config->get('vads_url_success') ;
		 	$this->redirect($url_success);
		  	die();
		 }
		 else {
		 	//	$url_error = $this->config->get('vads_url_error') ;
			 $this->redirect($url_error);
			die();
		 }	
		}
	}
}
?>